/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 05/14/2014
Author  : PerTic@n
Company : If You Like This Software,Buy It
Comments: 


Chip type               : ATmega16
Program type            : Application
AVR Core Clock frequency: 8.000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega16.h>
#include <delay.h>

// Alphanumeric LCD functions
#include <alcd.h>

#ifndef RXB8
#define RXB8 1
#endif

#ifndef TXB8
#define TXB8 0
#endif

#ifndef UPE
#define UPE 2
#endif

#ifndef DOR
#define DOR 3
#endif

#ifndef FE
#define FE 4
#endif

#ifndef UDRE
#define UDRE 5
#endif

#ifndef RXC
#define RXC 7
#endif

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<DOR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// Define Slave ID , Buttons And Led Pins
#define Slave_1_ID      0x55
#define Slave_2_ID      0xF0
#define Slave_3_ID      0x66
#define Slave_4_ID      0xF6
#define Timeout_value   50

#define Up PINB.0
#define Down PINB.1
#define Enter PINB.2
#define High_Temp PINB.3

#define Salon1 PORTA.0
#define Salon2 PORTA.1
#define Salon3 PORTA.2
#define Salon4 PORTA.3

unsigned char compare=0,set=0xff;
float Slave0=0.0, Slave1=0.0, Slave2=0.0, Slave3=0.0;
char lcd_buf0[],lcd_buf1[],lcd_buf2[],lcd_buf3[], lcd_buf4[];

void Send_ID(unsigned char);
unsigned char Receive_Data(void);

volatile unsigned char Data,Timeout;

// USART Receiver buffer
#define RX_BUFFER_SIZE 8
char rx_buffer[RX_BUFFER_SIZE];

#if RX_BUFFER_SIZE <= 256
unsigned char rx_wr_index,rx_rd_index,rx_counter;
#else
unsigned int rx_wr_index,rx_rd_index,rx_counter;
#endif

// This flag is set on USART Receiver buffer overflow
bit rx_buffer_overflow;

// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
   rx_buffer[rx_wr_index++]=data;
#if RX_BUFFER_SIZE == 256
   // special case for receiver buffer size=256
   if (++rx_counter == 0) rx_buffer_overflow=1;
#else
   if (rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
   if (++rx_counter == RX_BUFFER_SIZE)
      {
      rx_counter=0;
      rx_buffer_overflow=1;
      }
#endif
   }
}

#ifndef _DEBUG_TERMINAL_IO_
// Get a character from the USART Receiver buffer
#define _ALTERNATE_GETCHAR_
#pragma used+
char getchar(void)
{
char data;
while (rx_counter==0);
data=rx_buffer[rx_rd_index++];
#if RX_BUFFER_SIZE != 256
if (rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
#endif
#asm("cli")
--rx_counter;
#asm("sei")
return data;
}
#pragma used-
#endif

// Standard Input/Output functions
#include <stdio.h>

// Timer 0 output compare interrupt service routine
interrupt [TIM0_COMP] void timer0_comp_isr(void)
{
// Place your code here
 if(Timeout)Timeout--;
}

// Declare your global variables here

void inc_set_temp(){
if(compare<99) compare++;
}

void dec_set_temp(){
if(compare!=0) compare--;
}

void main(void)
{
// Declare your local variables here
unsigned char temp;

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=T State3=0 State2=0 State1=0 State0=0 
PORTA=0x00;
DDRA=0x0F;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: T0 pin Rising Edge
// Mode: Normal top=0xFF
// OC0 output: Disconnected
TCCR0=0x07;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x02;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x33;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

// Alphanumeric LCD initialization
// Connections are specified in the
// Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
// RS - PORTC Bit 0
// RD - PORTC Bit 1
// EN - PORTC Bit 2
// D4 - PORTC Bit 4
// D5 - PORTC Bit 5
// D6 - PORTC Bit 6
// D7 - PORTC Bit 7
// Characters/line: 16
lcd_init(16);

// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here
       Send_ID(Slave_1_ID);
       temp=Receive_Data();
       if(Up == 0) inc_set_temp();
       if(Down == 0) dec_set_temp();
       if(Enter == 0) set = compare;
       if(High_Temp == 0){
       sprintf(lcd_buf4,"High Temp:%i",compare);
       lcd_clear();
       lcd_gotoxy(2,2);
       lcd_puts(lcd_buf4);
       }
       delay_ms(1);
       // Slave 1
       if(temp && Data) {
       Slave0 = Receive_Data();
       if(Slave0 <= set) Salon1 = 1;
       else Salon1 = 0;
       sprintf(lcd_buf0,"Temp:%2.1f\xdfC",Slave0);
       lcd_gotoxy(0,0);
       lcd_puts(lcd_buf0);
       lcd_gotoxy(13,0);
       if(Salon1 == 1) lcd_putsf("on");
       if(Salon1 == 0) lcd_putsf("off");
       }
       // Slave 2
       delay_ms(1);
       Send_ID(Slave_2_ID);
       temp = Receive_Data();
       delay_ms(1);
       if(temp && Data) {
       Slave1 = Receive_Data();
       if(Slave1<=set) Salon2 = 1;
       else Salon2 = 0;
       sprintf(lcd_buf1,"Temp:%2.1f\xdfC",Slave1);
       lcd_gotoxy(0,1);
       lcd_puts(lcd_buf1);
       lcd_gotoxy(13,1);
       if(Salon2==1) lcd_putsf("on");
       if(Salon2==0) lcd_putsf("off");
       }
       // Slave 3
       delay_ms(1);
       Send_ID(Slave_3_ID);
       temp=Receive_Data();
       delay_ms(1);
       if(temp && Data) {
       Slave2 = Receive_Data();
       if(Slave2<=set) Salon3 = 1;
       else Salon3 = 0;
       sprintf(lcd_buf2,"Temp:%2.1f\xdfC",Slave2);
       lcd_gotoxy(0,2);
       lcd_puts(lcd_buf2);
       lcd_gotoxy(13,2);
       if(Salon3 == 1) lcd_putsf("on");
       if(Salon3 == 0) lcd_putsf("off");
       }
       // Salon 4
       delay_ms(1);
       Send_ID(Slave_4_ID);
       temp = Receive_Data();
       delay_ms(1);
       if(temp && Data) {
       Slave3 = Receive_Data();
       if(Slave3 <= set) Salon4 = 1;
       else Salon4 = 0;
       sprintf(lcd_buf3,"Temp:%2.1f\xdfC",Slave3);
       lcd_gotoxy(0,3);
       lcd_puts(lcd_buf3);
       lcd_gotoxy(13,3);
       if(Salon4 == 1) lcd_putsf("on");
       if(Salon4 == 0) lcd_putsf("off");
       }
      }
}
// Send ID
 void Send_ID(unsigned char ID)
{
 UCSRB=(1<<RXEN)|(1<<TXEN)|(1<<UCSZ2)|(1<<TXB8); // 9th bit = 1
 UDR=ID;
 while(!(UCSRA & (1<<TXC)));
 UCSRA=(1<<TXC);
}
// Received data
unsigned char Receive_Data(void)
{
 unsigned char temp;
 Timeout=Timeout_value;
 do
 {
  if(Timeout==0)return 0;
 }
 while(!(UCSRA & (1<<RXC)));
 temp=UCSRB;
 Data=UDR;
 return 1;
}